/***    Windows Application --- Menu example     ***/
/***                                             ***/
/***    WMENU-1 includes                         ***/
/***            (1) WMENU-1.C                    ***/
/***            (2) WMENU-1.RES                  ***/
/***            (3) WMENU-1.DEF                  ***/

#pragma hdrfile "windows.sym"
#include <windows.h>
#pragma hdrstop

#include "wmenu.h"

// Declaration

void InitFirstInstance(HANDLE) ;
void InitEachInstance(HANDLE, int) ;
long FAR PASCAL AppWndProc (HWND, WORD, WORD, LONG) ;

static char  szAppName[]  = "WinMenu" ;
static char  szMenuName[] = "WMenu" ;
HWND  hwnd ;

// Definition

int PASCAL WinMain(HANDLE hInstance,
		   HANDLE hPrevInstance,
		   LPSTR  lpszCmdLine,
		   int    nCmdShow)
{ MSG msg ;

  if ( !hPrevInstance ) InitFirstInstance(hInstance) ;

  InitEachInstance(hInstance,nCmdShow) ;

  while ( GetMessage(&msg, NULL, 0, 0) )
    { TranslateMessage(&msg) ;
      DispatchMessage(&msg) ;
    }
  return msg.wParam ;
}


void InitFirstInstance(HANDLE hInstance)
{ WNDCLASS wndclass ;

  wndclass.style	  = CS_HREDRAW | CS_VREDRAW ;
  wndclass.lpfnWndProc	  = AppWndProc ;
  wndclass.cbClsExtra 	  = 0 ;
  wndclass.cbWndExtra	  = 0 ;
  wndclass.hInstance      = hInstance ;
  wndclass.hIcon       	  = LoadIcon(NULL,IDI_APPLICATION) ;
  wndclass.hCursor	  = LoadCursor(NULL,IDC_ARROW) ;
  wndclass.hbrBackground  = GetStockObject(WHITE_BRUSH) ;
  wndclass.lpszMenuName	  = szMenuName ;
  wndclass.lpszClassName  = szAppName ;

  RegisterClass(&wndclass) ;
}


void InitEachInstance(HANDLE hInstance, int nCmdShow)
{
  hwnd = CreateWindow(szAppName,               // window class name
		      "Windows Application", // window caption
		      WS_OVERLAPPEDWINDOW ,
		      CW_USEDEFAULT,      // initial x position
		      0,                  // initial y position
		      CW_USEDEFAULT,      // initial x length
		      0,                  // initial y length
		      NULL,               // parent window handle
		      NULL,               // window menu handle
		      hInstance,          // program instance handle
		      NULL) ;             // parameters

  ShowWindow(hwnd,nCmdShow) ;
  UpdateWindow(hwnd) ;
}


long FAR PASCAL AppWndProc (HWND hwnd,
			    WORD message,
			    WORD wParam,
			    LONG lParam)
{ switch (message)
    { case WM_COMMAND :
	   switch(wParam)
	     { case IDM_CURSOR1 :
		    MessageBox(hwnd,"CURSOR1 process","HintWindow",MB_OK) ;
		    break ;

	       case IDM_CURSOR2 :
		    MessageBox(hwnd,"CURSOR2 process","HintWindow",MB_OK) ;
		    break ;

	       case IDM_CURSOR3 :
		    MessageBox(hwnd,"CURSOR3 process","HintWindow",MB_OK) ;
		    break ;

	       case IDM_ICON1 :
		    MessageBox(hwnd,"ICON1 process","HintWindow",MB_OK) ;
		    break ;

	       case IDM_ICON2 :
		    MessageBox(hwnd,"ICON2 process","HintWindow",MB_OK) ;
		    break ;

	       case IDM_BITMAP1 :
		    MessageBox(hwnd,"BITMAP1 process","HintWindow",MB_OK) ;
		    break ;

	       case IDM_BITMAP2 :
		    MessageBox(hwnd,"BITMAP2 process","HintWindow",MB_OK) ;
		    break ;

	       case IDM_BITMAP3 :
		    MessageBox(hwnd,"BITMAP3 process","HintWindow",MB_OK) ;
		    break ;
	     }
	   break ;

      case WM_DESTROY :
	   PostQuitMessage(0) ;
	   break ;

      default :
	   return DefWindowProc(hwnd, message, wParam, lParam) ;
    }

  return 0 ;
}

